#include <dir.h>
#include "DynamicDLLTestWndProcFunctions.h"
#include "DynamicDLLTestWMCommandFunctions.h"

#define ID_LISTBOX 1000
#define ID_BUTTON  1001
HWND hListbox = 0;
HWND hButton  = 0;

//==============================================================================
//
//==============================================================================
#pragma argsused
int fnWMShowWindow (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   char          szDLLPfad [MAXPATH]; // Namensspeicher fr die DLL incl. Pfad -
   char         *pszHelp;
   struct ffblk  rFileBlock;
   int           bFailed;
   HWND          hLB;

   //---------------------------------------------------------------------------
   // Handle der Listbox ermitteln
   //---------------------------------------------------------------------------
   hLB = GetDlgItem (hWnd, ID_LISTBOX);

   //---------------------------------------------------------------------------
   // Namensmuster der DLLs fr die Listbox ermitteln und in Listbox stellen
   //---------------------------------------------------------------------------
   strcpy (szDLLPfad, _argv[0]);
   pszHelp = strrchr (szDLLPfad, '\\');
   if (pszHelp)
   {
      pszHelp++;
      *pszHelp = '\0';
      lstrcat (szDLLPfad, "xx*.dll");
   }

   //---------------------------------------------------------------------------
   // gem Namensmuster der DLL das Verzeichnis durchsuchen
   //---------------------------------------------------------------------------
   bFailed = findfirst (szDLLPfad, &rFileBlock, 0);
   while (!bFailed)
   {
      SendMessage (hLB, LB_ADDSTRING, (WPARAM)0, (LPARAM)rFileBlock.ff_name);
      bFailed = findnext (&rFileBlock);
   }
   return 0;
}

//==============================================================================
//
//==============================================================================
#pragma argsused
int fnWMCreate (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   hListbox = CreateWindow("listbox", NULL,
                         WS_CHILD | WS_VISIBLE | LBS_STANDARD,
                         0, 0, 100, 150,
                         hWnd, (HMENU)ID_LISTBOX,
                         (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   hButton = CreateWindow("button", "Start",
                         WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
                         200, 0, 100, 20,
                         hWnd, (HMENU)ID_BUTTON,
                         (HINSTANCE)GetWindowLong (hWnd, GWL_HINSTANCE), NULL);
   return 0;
}

//==============================================================================
//
//==============================================================================
#pragma argsused
int fnWMCommand (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   switch (wParam)
   {
      case ID_BUTTON: return fnButton (hWnd, wParam, lParam, ID_LISTBOX);
   }
}

//==============================================================================
//
//==============================================================================
#pragma argsused
int fnWMDestroy (HWND hWnd, WPARAM wParam, LPARAM lParam)
{
   PostQuitMessage (0);
   return 0;
}
